#include <alloc.h>
#include <stdio.h>
#include <string.h>
#include "dx.h"
#include "define.h"
#include "buffers.h"
#include "symbol.h"
#include "tools.h"

extern char	STREAMS_callsign[MAX_STREAMS][10];
extern char	STREAMS_level[MAX_STREAMS];

struct
{
  char NodeCall[10];
  char Logger[10];
  char DxCall[15];
  char Comments[31];
  char Date[12];
  char Time[5];
  unsigned long Frequency;
} DxSpot;

//---------------------------------------------------------------------------
//------ Ajouter un DX dans le fichier DX -----------------------------------
//---------------------------------------------------------------------------
void DX_add(char * DxCall, unsigned long Frequency, char * Comments, char * Time, char * Date, char * Logger, char * NodeCall)
{
  FILE * fPtr;

  //------ Ouvrir le fichier et placer le nouveau DX  la fin ------------
  fPtr = fopen(DX_FILE, "a+b");

  if( ! fPtr )	//Le fichier n'a pu tre ouvert
  {
    perror("fopen in DX_add");
    return;
  }

  //Limiter la longueur des champs
  TOOLS_maxLength(NodeCall, 9);
//  if( PARAMS_iSetDxSsid == FALSE )	//Ne pas enlever le ssid si le sysop l'a declare ainsi
//    TOOLS_removeSsid(Logger);
  TOOLS_maxLength(Logger, 9);
  TOOLS_maxLength(DxCall, 14);
  TOOLS_maxLength(Comments, 30);
  TOOLS_maxLength(Date, 11);
  TOOLS_maxLength(Time, 4);

  //Prparer tous les champs de l'enregistrement
  memset(&DxSpot, 0, sizeof(DxSpot));		//pour rendre le fichier plus clean
  strcpy(DxSpot.NodeCall, 	NodeCall);
  strcpy(DxSpot.Logger,   	Logger);
  strcpy(DxSpot.DxCall,  	DxCall);
  strcpy(DxSpot.Comments,	Comments);
  strcpy(DxSpot.Date,		Date);
  strcpy(DxSpot.Time,		Time);
  DxSpot.Frequency = Frequency;

  //Enregistrer le DX  la fin du fichier
  fwrite(&DxSpot, sizeof(DxSpot), 1, fPtr);

  fclose(fPtr);
}

//---------------------------------------------------------------------------
//------ Vrifier la validit de la frquence -------------------------------
//---------------------------------------------------------------------------
//La fonctionne retourne la bande correspodant  la Frquence et 0 sinon
int DX_checkFrequency(unsigned long Frequency)
{
  int Done = 0;

  if( Frequency >= 18000L 	&&	Frequency <= 20000L )
    Done = 160;
  else
  if( Frequency >= 35000L 	&&	Frequency <= 40000L )
    Done = 80;
  else
  if( Frequency >= 70000L 	&&	Frequency <= 73000L )
    Done = 40;
  else
  if( Frequency >= 100000L 	&&	Frequency <= 101500L )
    Done = 30;
  else
  if( Frequency >= 140000L 	&&	Frequency <= 143500L )
    Done = 20;
  else
  if( Frequency >= 180680L 	&&	Frequency <= 181680L )
    Done = 17;
  else
  if( Frequency >= 210000L 	&&	Frequency <= 214500L )
    Done = 15;
  else
  if( Frequency >= 248900L 	&&	Frequency <= 249900L )
    Done = 12;
  else
  if( Frequency >= 280000L 	&&	Frequency <= 297000L )
    Done = 10;
  else
  if( Frequency >= 500000L 	&&	Frequency <= 540000L )
    Done = 6;
  else
  if( Frequency >= 700000L 	&&	Frequency <= 705000L )
    Done = 4;
  else
  if( Frequency >= 1440000L 	&&	Frequency <= 1480000L )
    Done = 2;
  else
  if( Frequency >= 2200000L 	&&	Frequency <= 2250000L )
    Done = 135;
  else
  if( Frequency >= 4200000L 	&&	Frequency <= 4500000L )
    Done = 70;
  else
  if( Frequency >= 9020000L 	&&	Frequency <= 9280000L )
    Done = 34;
  else
  if( Frequency >= 12400000L 	&&	Frequency <= 13000000L )
    Done = 23;
  else
  if( Frequency >= 23000000L 	&&	Frequency <= 24500000L )
    Done = 13;
  else
  if( Frequency >= 56500000L 	&&	Frequency <= 58500000L )
    Done = 5;
  else
  if( Frequency >= 100000000L 	&&	Frequency <= 105000000L )
    Done = 3;
  else
  if( Frequency >= 240000000L 	&&	Frequency <= 245000000L )
    Done = 1;

  return Done;
}

//---------------------------------------------------------------------------
//------ Charger un DX du fichier DX ----------------------------------------
//---------------------------------------------------------------------------
//La fonction retourne TRUE si le DX a pu tre lu
int DX_get(int Pos, char * DxCall, unsigned long * Frequency, char * Comments, char * Time, char * Date, char * Logger, char * NodeCall)
{
  FILE *fPtr;
  long	lOffset;

  //------ Ouvrir le fichier -------
  fPtr = fopen(DX_FILE, "rb");

  if( ! fPtr )	//Le fichier n'a pu tre ouvert
  {
    perror("fopen in DX_get");
    return FALSE;
  }

  //Se placer  la fin du fichier
  fseek(fPtr, 0L, SEEK_END);

  //Remonter de Pos enregistrements
  lOffset =  (long) Pos * (long) sizeof(DxSpot);
  if( lOffset > ftell(fPtr) )
  {
    fclose( fPtr );
    return FALSE;
  }
  fseek(fPtr, -lOffset, SEEK_CUR);

  //Extraire les champs
  fread(&DxSpot, sizeof(DxSpot), 1, fPtr);

  //Passer les champs aux variables
  strcpy(NodeCall, 	DxSpot.NodeCall);
  strcpy(Logger,   	DxSpot.Logger);
  strcpy(DxCall,  	DxSpot.DxCall);
  strcpy(Comments,	DxSpot.Comments);
  strcpy(Date,		DxSpot.Date);
  strcpy(Time,		DxSpot.Time);
  *Frequency = DxSpot.Frequency;

  //Fermer le fichier et retourner
  fclose( fPtr );
  return TRUE;
}

/*---------------------------------------------------------------------------
  ------ Rechercher si le spot DX est un double -----------------------------
  ---------------------------------------------------------------------------
  La fonction retourne TRUE si le DX est double */
int DX_isDupe(char * DxCall, unsigned long Frequency, char * Comments, char * Time, char * Logger)
{
	#define	NLAST	50L
	FILE   *fPtr;
	long	lOffset;
	int	index;
	char	szLogger[16];

	/* Recherche de DUPE a effectuer qqs le SSID du logger */
	strcpy(szLogger, Logger);
	TOOLS_removeSsid(szLogger);

	/* Ouvrir le fichier */
	fPtr = fopen(DX_FILE, "rb");

	if( ! fPtr )	/* Impossible d'ouvrir */
	{
		perror("fopen in DX_isDupe");
		return FALSE;
	}

	/* Placer le pointeur de fichier NLAST spots en arriere */
	fseek(fPtr, 0L, SEEK_END);			/* Fin du fichier */
	lOffset =  NLAST * (long) sizeof(DxSpot);		/* Calcul offset */
	if( lOffset > ftell(fPtr) )
		fseek(fPtr, 0L, SEEK_SET);		/* Moins de NLAST spots enregistres : se placer en debut de fichier */
	else
		fseek(fPtr, -lOffset, SEEK_CUR);	/* Pointer NLAST */

	/* Tester chacun des spots */
	for(index = 0; index < NLAST; index++)
	{
		/* Lecture enregistrement */
		if( ! fread(&DxSpot, sizeof(DxSpot), 1, fPtr) )
			break;	/* EOF */

		/* Comparer ... */
		TOOLS_removeSsid(DxSpot.Logger);	/* Qqs le SSID du logger */
		if( ! strcmp(DxCall, DxSpot.DxCall)     &&
		      Frequency == DxSpot.Frequency     &&
		    ! strcmp(Comments, DxSpot.Comments) &&
		    ! strcmp(Time, DxSpot.Time)         &&
		    ! strcmp(szLogger, DxSpot.Logger)  )
		{
			/* DUPE */
			fclose( fPtr );
			return TRUE;
		}

	}/* End FOR */

	/* Fermer le fichier et retourner */
	fclose( fPtr );
	return FALSE;
}